monads-tf-0.3.0.1: Monad classes, using type families

Copyright | (c) Andy Gill 2001 (c) Oregon Graduate Institute of Science and Technology 2001 (c) Jeff Newbern 2003-2007 (c) Andriy Palamarchuk 2007
License | BSD-style (see the file LICENSE)
Maintainer | ross@soi.city.ac.uk
Stability | experimental
Portability | non-portable (type families)
Safe Haskell | None
Language | GHC2021

Control.Monad.Reader

Contents

- MonadReader class
- The Reader monad
- The ReaderT monad transformer
- Example 1: Simple Reader Usage
- Example 2: Modifying Reader Content With `local`
- Example 3: `ReaderT` Monad Transformer

Description

Computation type:
  Computations which read values from a shared environment.
Binding strategy:
  Monad values are functions from the environment to a value. The bound function is applied to the bound value, and both have access to the shared environment.
Useful for:
  Maintaining variable bindings, or other shared environment.
Zero and plus:
  None.
Example type:
  ``Reader` [(String,Value)] a`

The `Reader` monad (also called the Environment monad). Represents a computation, which can read values from a shared environment, pass values from function to function, and execute sub-computations in a modified environment. Using `Reader` monad for such computations is often clearer and easier than using the `State` monad.

Inspired by the paper /Functional Programming with Overloading and Higher-Order Polymorphism/, Mark P Jones (http://web.cecs.pdx.edu/~mpj/) Advanced School of Functional Programming, 1995.

Synopsis

- class Monad m => MonadReader (m :: Type -> Type) where
  - type EnvType (m :: Type -> Type)
  - ask :: m (EnvType m)
  - local :: (EnvType m -> EnvType m) -> m a -> m a
- asks :: MonadReader m => (EnvType m -> a) -> m a
- type Reader r = ReaderT r Identity
- runReader :: Reader r a -> r -> a
- mapReader :: (a -> b) -> Reader r a -> Reader r b
- withReader :: (r' -> r) -> Reader r a -> Reader r' a
- newtype ReaderT r (m :: Type -> Type) a = ReaderT {
  - runReaderT :: r -> m a
  }
- mapReaderT :: (m a -> n b) -> ReaderT r m a -> ReaderT r n b
- withReaderT :: forall r' r (m :: Type -> Type) a. (r' -> r) -> ReaderT r m a -> ReaderT r' m a
- module Control.Monad
- module Control.Monad.Fix
- module Control.Monad.Trans

# MonadReader class

class Monad m => MonadReader (m :: Type -> Type) where Source #

See examples in Control.Monad.Reader. Note, the partially applied function type `(->) r` is a simple reader monad. See the `instance` declaration below.

Associated Types

type EnvType (m :: Type -> Type) Source #

Methods

ask :: m (EnvType m) Source #

Retrieves the monad environment.

local Source #

Arguments

:: (EnvType m -> EnvType m) | The function to modify the environment.
-> m a | `Reader` to run in the modified environment.
-> m a |

Executes a computation in a modified environment.

#### Instances

Instances details

MonadReader m => MonadReader (MaybeT m) Source # |

Instance details

Defined in Control.Monad.Reader.Class

Associated Types

type EnvType (MaybeT m) |
Instance details Defined in Control.Monad.Reader.Class type EnvType (MaybeT m) = EnvType m

Methods

ask :: MaybeT m (EnvType (MaybeT m)) Source #

local :: (EnvType (MaybeT m) -> EnvType (MaybeT m)) -> MaybeT m a -> MaybeT m a Source #

MonadReader m => MonadReader (ExceptT e m) Source # |

Instance details

Defined in Control.Monad.Reader.Class

Associated Types

type EnvType (ExceptT e m) |
Instance details Defined in Control.Monad.Reader.Class type EnvType (ExceptT e m) = EnvType m

Methods

ask :: ExceptT e m (EnvType (ExceptT e m)) Source #

local :: (EnvType (ExceptT e m) -> EnvType (ExceptT e m)) -> ExceptT e m a -> ExceptT e m a Source #

MonadReader m => MonadReader (IdentityT m) Source # |

Instance details

Defined in Control.Monad.Reader.Class

Associated Types

type EnvType (IdentityT m) |
Instance details Defined in Control.Monad.Reader.Class type EnvType (IdentityT m) = EnvType m

Methods

ask :: IdentityT m (EnvType (IdentityT m)) Source #

local :: (EnvType (IdentityT m) -> EnvType (IdentityT m)) -> IdentityT m a -> IdentityT m a Source #

Monad m => MonadReader (ReaderT r m) Source # |

Instance details

Defined in Control.Monad.Reader.Class

Associated Types

type EnvType (ReaderT r m) |
Instance details Defined in Control.Monad.Reader.Class type EnvType (ReaderT r m) = r

Methods

ask :: ReaderT r m (EnvType (ReaderT r m)) Source #

local :: (EnvType (ReaderT r m) -> EnvType (ReaderT r m)) -> ReaderT r m a -> ReaderT r m a Source #

MonadReader m => MonadReader (StateT s m) Source # |

Instance details

Defined in Control.Monad.Reader.Class

Associated Types

type EnvType (StateT s m) |
Instance details Defined in Control.Monad.Reader.Class type EnvType (StateT s m) = EnvType m

Methods

ask :: StateT s m (EnvType (StateT s m)) Source #

local :: (EnvType (StateT s m) -> EnvType (StateT s m)) -> StateT s m a -> StateT s m a Source #

MonadReader m => MonadReader (StateT s m) Source # |

Instance details

Defined in Control.Monad.Reader.Class

Associated Types

type EnvType (StateT s m) |
Instance details Defined in Control.Monad.Reader.Class type EnvType (StateT s m) = EnvType m

Methods

ask :: StateT s m (EnvType (StateT s m)) Source #

local :: (EnvType (StateT s m) -> EnvType (StateT s m)) -> StateT s m a -> StateT s m a Source #

(Monoid w, MonadReader m) => MonadReader (WriterT w m) Source # |

Instance details

Defined in Control.Monad.Reader.Class

Associated Types

type EnvType (WriterT w m) |
Instance details Defined in Control.Monad.Reader.Class type EnvType (WriterT w m) = EnvType m

Methods

ask :: WriterT w m (EnvType (WriterT w m)) Source #

local :: (EnvType (WriterT w m) -> EnvType (WriterT w m)) -> WriterT w m a -> WriterT w m a Source #

(Monoid w, MonadReader m) => MonadReader (WriterT w m) Source # |

Instance details

Defined in Control.Monad.Reader.Class

Associated Types

type EnvType (WriterT w m) |
Instance details Defined in Control.Monad.Reader.Class type EnvType (WriterT w m) = EnvType m

Methods

ask :: WriterT w m (EnvType (WriterT w m)) Source #

local :: (EnvType (WriterT w m) -> EnvType (WriterT w m)) -> WriterT w m a -> WriterT w m a Source #

MonadReader m => MonadReader (ContT r m) Source # |

Instance details

Defined in Control.Monad.Reader.Class

Associated Types

type EnvType (ContT r m) |
Instance details Defined in Control.Monad.Reader.Class type EnvType (ContT r m) = EnvType m

Methods

ask :: ContT r m (EnvType (ContT r m)) Source #

local :: (EnvType (ContT r m) -> EnvType (ContT r m)) -> ContT r m a -> ContT r m a Source #

MonadReader ((->) r) Source # |

Instance details

Defined in Control.Monad.Reader.Class

Associated Types

type EnvType ((->) r) |
Instance details Defined in Control.Monad.Reader.Class type EnvType ((->) r) = r

Methods

ask :: r -> EnvType ((->) r) Source #

local :: (EnvType ((->) r) -> EnvType ((->) r)) -> (r -> a) -> r -> a Source #

(Monoid w, Monad m) => MonadReader (RWST r w s m) Source # |

Instance details

Defined in Control.Monad.Reader.Class

Associated Types

type EnvType (RWST r w s m) |
Instance details Defined in Control.Monad.Reader.Class type EnvType (RWST r w s m) = r

Methods

ask :: RWST r w s m (EnvType (RWST r w s m)) Source #

local :: (EnvType (RWST r w s m) -> EnvType (RWST r w s m)) -> RWST r w s m a -> RWST r w s m a Source #

(Monoid w, Monad m) => MonadReader (RWST r w s m) Source # |

Instance details

Defined in Control.Monad.Reader.Class

Associated Types

type EnvType (RWST r w s m) |
Instance details Defined in Control.Monad.Reader.Class type EnvType (RWST r w s m) = r

Methods

ask :: RWST r w s m (EnvType (RWST r w s m)) Source #

local :: (EnvType (RWST r w s m) -> EnvType (RWST r w s m)) -> RWST r w s m a -> RWST r w s m a Source #

asks Source #

Arguments

:: MonadReader m |
=> (EnvType m -> a) | The selector function to apply to the environment.
-> m a |

Retrieves a function of the current environment.

# The Reader monad

type Reader r = ReaderT r Identity Source #

The parameterizable reader monad.

Computations are functions of a shared environment.

The `return` function ignores the environment, while `m `>>=` k` passes the inherited environment to both subcomputations:

runReader Source #

Arguments

:: Reader r a | A `Reader` to run.
-> r | An initial environment.
-> a |

Runs a `Reader` and extracts the final value from it. (The inverse of `reader`.)

mapReader :: (a -> b) -> Reader r a -> Reader r b Source #

Transform the value returned by a `Reader`.

-     runReader (mapReader f m) = f . runReader m

withReader Source #

Arguments

:: (r' -> r) | The function to modify the environment.
-> Reader r a | Computation to run in the modified environment.
-> Reader r' a |

Execute a computation in a modified environment (a specialization of `withReaderT`).

-     runReader (withReader f m) = runReader m . f

# The ReaderT monad transformer

newtype ReaderT r (m :: Type -> Type) a Source #

The reader monad transformer, which adds a read-only environment to the given monad.

The `return` function ignores the environment, while `m `>>=` k` passes the inherited environment to both subcomputations:

Constructors

ReaderT |

Fields

- runReaderT :: r -> m a

#### Instances

Instances details

Generic1 (ReaderT r m :: Type -> Type) |

Instance details

Defined in Control.Monad.Trans.Reader

Associated Types

type Rep1 (ReaderT r m :: Type -> Type) |
Instance details Defined in Control.Monad.Trans.Reader type Rep1 (ReaderT r m :: Type -> Type) = D1 ('MetaData "ReaderT" "Control.Monad.Trans.Reader" "transformers-0.6.1.1-inplace" 'True) (C1 ('MetaCons "ReaderT" 'PrefixI 'True) (S1 ('MetaSel ('Just "runReaderT") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) ((FUN 'Many r :: Type -> Type) :.: Rec1 m)))

Methods

from1 :: ReaderT r m a -> Rep1 (ReaderT r m) a Source #

to1 :: Rep1 (ReaderT r m) a -> ReaderT r m a Source #

MonadTrans (ReaderT r) |
Instance details Defined in Control.Monad.Trans.Reader Methods lift :: Monad m => m a -> ReaderT r m a Source #
MonadIO m => MonadIO (ReaderT r m) |
Instance details Defined in Control.Monad.Trans.Reader Methods liftIO :: IO a -> ReaderT r m a Source #
MonadZip m => MonadZip (ReaderT r m) |
Instance details Defined in Control.Monad.Trans.Reader Methods mzip :: ReaderT r m a -> ReaderT r m b -> ReaderT r m (a, b) Source # mzipWith :: (a -> b -> c) -> ReaderT r m a -> ReaderT r m b -> ReaderT r m c Source # munzip :: ReaderT r m (a, b) -> (ReaderT r m a, ReaderT r m b) Source #
Contravariant m => Contravariant (ReaderT r m) |
Instance details Defined in Control.Monad.Trans.Reader Methods contramap :: (a' -> a) -> ReaderT r m a -> ReaderT r m a' Source # (>$) :: b -> ReaderT r m b -> ReaderT r m a Source #
Alternative m => Alternative (ReaderT r m) |
Instance details Defined in Control.Monad.Trans.Reader Methods empty :: ReaderT r m a Source # (<|>) :: ReaderT r m a -> ReaderT r m a -> ReaderT r m a Source # some :: ReaderT r m a -> ReaderT r m [a] Source # many :: ReaderT r m a -> ReaderT r m [a] Source #
Applicative m => Applicative (ReaderT r m) |
Instance details Defined in Control.Monad.Trans.Reader Methods pure :: a -> ReaderT r m a Source # (<*>) :: ReaderT r m (a -> b) -> ReaderT r m a -> ReaderT r m b Source # liftA2 :: (a -> b -> c) -> ReaderT r m a -> ReaderT r m b -> ReaderT r m c Source # (*>) :: ReaderT r m a -> ReaderT r m b -> ReaderT r m b Source # (<*) :: ReaderT r m a -> ReaderT r m b -> ReaderT r m a Source #
Functor m => Functor (ReaderT r m) |
Instance details Defined in Control.Monad.Trans.Reader Methods fmap :: (a -> b) -> ReaderT r m a -> ReaderT r m b Source # (<$) :: a -> ReaderT r m b -> ReaderT r m a Source #
Monad m => Monad (ReaderT r m) |
Instance details Defined in Control.Monad.Trans.Reader Methods (>>=) :: ReaderT r m a -> (a -> ReaderT r m b) -> ReaderT r m b Source # (>>) :: ReaderT r m a -> ReaderT r m b -> ReaderT r m b Source # return :: a -> ReaderT r m a Source #
MonadPlus m => MonadPlus (ReaderT r m) |
Instance details Defined in Control.Monad.Trans.Reader Methods mzero :: ReaderT r m a Source # mplus :: ReaderT r m a -> ReaderT r m a -> ReaderT r m a Source #
MonadFail m => MonadFail (ReaderT r m) |
Instance details Defined in Control.Monad.Trans.Reader Methods fail :: String -> ReaderT r m a Source #
MonadFix m => MonadFix (ReaderT r m) |
Instance details Defined in Control.Monad.Trans.Reader Methods mfix :: (a -> ReaderT r m a) -> ReaderT r m a Source #
MonadCont m => MonadCont (ReaderT r m) Source # |
Instance details Defined in Control.Monad.Cont.Class Methods callCC :: ((a -> ReaderT r m b) -> ReaderT r m a) -> ReaderT r m a Source #
MonadError m => MonadError (ReaderT r m) Source # |

Instance details

Defined in Control.Monad.Except.Class

Associated Types

type ErrorType (ReaderT r m) |
Instance details Defined in Control.Monad.Except.Class type ErrorType (ReaderT r m) = ErrorType m

Methods

throwError :: ErrorType (ReaderT r m) -> ReaderT r m a Source #

catchError :: ReaderT r m a -> (ErrorType (ReaderT r m) -> ReaderT r m a) -> ReaderT r m a Source #

Monad m => MonadReader (ReaderT r m) Source # |

Instance details

Defined in Control.Monad.Reader.Class

Associated Types

type EnvType (ReaderT r m) |
Instance details Defined in Control.Monad.Reader.Class type EnvType (ReaderT r m) = r

Methods

ask :: ReaderT r m (EnvType (ReaderT r m)) Source #

local :: (EnvType (ReaderT r m) -> EnvType (ReaderT r m)) -> ReaderT r m a -> ReaderT r m a Source #

MonadState m => MonadState (ReaderT r m) Source # |

Instance details

Defined in Control.Monad.State.Class

Associated Types

type StateType (ReaderT r m) |
Instance details Defined in Control.Monad.State.Class type StateType (ReaderT r m) = StateType m

Methods

get :: ReaderT r m (StateType (ReaderT r m)) Source #

put :: StateType (ReaderT r m) -> ReaderT r m () Source #

MonadWriter m => MonadWriter (ReaderT r m) Source # |

Instance details

Defined in Control.Monad.Writer.Class

Associated Types

type WriterType (ReaderT r m) |
Instance details Defined in Control.Monad.Writer.Class type WriterType (ReaderT r m) = WriterType m

Methods

tell :: WriterType (ReaderT r m) -> ReaderT r m () Source #

listen :: ReaderT r m a -> ReaderT r m (a, WriterType (ReaderT r m)) Source #

pass :: ReaderT r m (a, WriterType (ReaderT r m) -> WriterType (ReaderT r m)) -> ReaderT r m a Source #

Generic (ReaderT r m a) |

Instance details

Defined in Control.Monad.Trans.Reader

Associated Types

type Rep (ReaderT r m a) |
Instance details Defined in Control.Monad.Trans.Reader type Rep (ReaderT r m a) = D1 ('MetaData "ReaderT" "Control.Monad.Trans.Reader" "transformers-0.6.1.1-inplace" 'True) (C1 ('MetaCons "ReaderT" 'PrefixI 'True) (S1 ('MetaSel ('Just "runReaderT") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (r -> m a))))

Methods

from :: ReaderT r m a -> Rep (ReaderT r m a) x Source #

to :: Rep (ReaderT r m a) x -> ReaderT r m a Source #

type Rep1 (ReaderT r m :: Type -> Type) |
Instance details Defined in Control.Monad.Trans.Reader type Rep1 (ReaderT r m :: Type -> Type) = D1 ('MetaData "ReaderT" "Control.Monad.Trans.Reader" "transformers-0.6.1.1-inplace" 'True) (C1 ('MetaCons "ReaderT" 'PrefixI 'True) (S1 ('MetaSel ('Just "runReaderT") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) ((FUN 'Many r :: Type -> Type) :.: Rec1 m)))
type ErrorType (ReaderT r m) Source # |
Instance details Defined in Control.Monad.Except.Class type ErrorType (ReaderT r m) = ErrorType m
type EnvType (ReaderT r m) Source # |
Instance details Defined in Control.Monad.Reader.Class type EnvType (ReaderT r m) = r
type StateType (ReaderT r m) Source # |
Instance details Defined in Control.Monad.State.Class type StateType (ReaderT r m) = StateType m
type WriterType (ReaderT r m) Source # |
Instance details Defined in Control.Monad.Writer.Class type WriterType (ReaderT r m) = WriterType m
type Rep (ReaderT r m a) |
Instance details Defined in Control.Monad.Trans.Reader type Rep (ReaderT r m a) = D1 ('MetaData "ReaderT" "Control.Monad.Trans.Reader" "transformers-0.6.1.1-inplace" 'True) (C1 ('MetaCons "ReaderT" 'PrefixI 'True) (S1 ('MetaSel ('Just "runReaderT") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (r -> m a))))

mapReaderT :: (m a -> n b) -> ReaderT r m a -> ReaderT r n b Source #

Transform the computation inside a `ReaderT`.

-     runReaderT (mapReaderT f m) = f . runReaderT m

withReaderT Source #

Arguments

:: forall r' r (m :: Type -> Type) a. (r' -> r) | The function to modify the environment.
-> ReaderT r m a | Computation to run in the modified environment.
-> ReaderT r' m a |

Execute a computation in a modified environment (a more general version of `local`).

-     runReaderT (withReaderT f m) = runReaderT m . f

module Control.Monad

module Control.Monad.Fix

module Control.Monad.Trans

# Example 1: Simple Reader Usage

In this example the `Reader` monad provides access to variable bindings. Bindings are a `Map` of integer variables. The variable `count` contains number of variables in the bindings. You can see how to run a Reader monad and retrieve data from it with `runReader`, how to access the Reader data with `ask` and `asks`.

     type Bindings = Map String Int;

    -- Returns True if the "count" variable contains correct bindings size.
    isCountCorrect :: Bindings -> Bool
    isCountCorrect bindings = runReader calc_isCountCorrect bindings

    -- The Reader monad, which implements this complicated check.
    calc_isCountCorrect :: Reader Bindings Bool
    calc_isCountCorrect = do
        count <- asks (lookupVar "count")
        bindings <- ask
        return (count == (Map.size bindings))

    -- The selector function to  use with 'asks'.
    -- Returns value of the variable with specified name.
    lookupVar :: String -> Bindings -> Int
    lookupVar name bindings = fromJust (Map.lookup name bindings)

    sampleBindings = Map.fromList [("count",3), ("1",1), ("b",2)]

    main = do
        putStr $ "Count is correct for bindings " ++ (show sampleBindings) ++ ": ";
        putStrLn $ show (isCountCorrect sampleBindings);

# Example 2: Modifying Reader Content With `local`

Shows how to modify Reader content with `local`.

    calculateContentLen :: Reader String Int
    calculateContentLen = do
        content <- ask
        return (length content);

    -- Calls calculateContentLen after adding a prefix to the Reader content.
    calculateModifiedContentLen :: Reader String Int
    calculateModifiedContentLen = local ("Prefix " ++) calculateContentLen

    main = do
        let s = "12345";
        let modifiedLen = runReader calculateModifiedContentLen s
        let len = runReader calculateContentLen s
        putStrLn $ "Modified 's' length: " ++ (show modifiedLen)
        putStrLn $ "Original 's' length: " ++ (show len)

# Example 3: `ReaderT` Monad Transformer

Now you are thinking: 'Wow, what a great monad! I wish I could use Reader functionality in MyFavoriteComplexMonad!'. Don't worry. This can be easy done with the `ReaderT` monad transformer. This example shows how to combine `ReaderT` with the IO monad.

    -- The Reader/IO combined monad, where Reader stores a string.
    printReaderContent :: ReaderT String IO ()
    printReaderContent = do
        content <- ask
        liftIO $ putStrLn ("The Reader Content: " ++ content)

    main = do
        runReaderT printReaderContent "Some Content"